"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function ReduxModel() { }
var classCounter = {};
var isCompressed = typeof ReduxModel.name === 'string' && ReduxModel.name !== 'ReduxModel';
var instanceName = '';
var actionCounter = 0;
exports.setInstanceName = function (className, alias) {
    instanceName = className + (alias ? "." + alias : '');
    actionCounter = 0;
    var dictKey = "dict_" + instanceName;
    if (classCounter[dictKey] === undefined) {
        classCounter[dictKey] = 0;
    }
    else {
        classCounter[dictKey] += 1;
    }
    if (classCounter[dictKey] > 0) {
        instanceName += "-" + classCounter[dictKey];
    }
    // Hot-Reload can't be supported when bundle is compressed.
    if (!isCompressed) {
        // Low compact: User shouldn't create the same classname. Otherwise, alias is required.
        // Low compact: User must instance the same class at the same time. Otherwise, alias is required.
        setTimeout(function () {
            classCounter[dictKey] -= 1;
        });
    }
    return instanceName;
};
exports.getInstanceName = function () {
    return instanceName;
};
exports.increaseActionCounter = function () {
    actionCounter += 1;
    return actionCounter;
};
