"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vue_1 = tslib_1.__importDefault(require("vue"));
var clone_1 = tslib_1.__importDefault(require("clone"));
var diff_1 = require("./diff");
var store_1 = require("../core/utils/store");
store_1.onStoreCreated(function (store) {
    var getCurrentState = store.getState;
    var originalState = getCurrentState();
    var observer = vue_1.default.observable(clone_1.default(originalState));
    store.getState = function () {
        return observer;
    };
    store.subscribe(function () {
        var currentState = getCurrentState();
        if (currentState !== originalState) {
            diff_1.applyPatch(originalState, currentState, observer);
            originalState = currentState;
        }
    });
});
